#ifndef NDS_JAVA_BUFFERS_TYPE_I
#define NDS_JAVA_BUFFERS_TYPE_I

%typemap(jni) buffers_type "jobjectArray";
%typemap(jtype) buffers_type "buffer[]";
%typemap(jstype) buffers_type "buffer[]";
%typemap(javaout) buffers_type {
  return $jnicall;
}

%typemap(out) buffers_type {
  //---------------------------------------------------------------------
  // find out about the object to convert
  //---------------------------------------------------------------------
  jclass clazz = jenv->FindClass( "nds/buffer" );
  if ( ! clazz )
  {
    $cleanup;
    return $null;
  }
  jmethodID ctor = jenv->GetMethodID( clazz, "<init>", "(JZ)V" );
  if ( ! ctor )
  {
    $cleanup;
    return $null;
  }
  //---------------------------------------------------------------------
  // Allocate the space
  //---------------------------------------------------------------------
  $result = jenv->NewObjectArray( $1.size( ), clazz, NULL);
  if ( ! $result )
  {
    $cleanup;
    return $null;
  }
  //---------------------------------------------------------------------
  // Translate vector into array
  //---------------------------------------------------------------------
  jsize         i = 0;
  jlong         cptr;
  jobject       obj;
  for ( $1_basetype::iterator
          cur = $1.begin( ),
          last = $1.end( );
        cur != last;
        ++cur,
        ++i )
  {
    *($1_basetype::value_type**)(&cptr) = new $1_basetype::value_type(*cur);
    obj = jenv->NewObject( clazz, ctor, cptr, JNI_TRUE );
    if ( ! obj )
    {
      $cleanup;
      return $null;
    }
    jenv->SetObjectArrayElement( $result, i, obj );
  }
}

#endif /* NDS_JAVA_BUFFERS_TYPE_I */
